<ng-container *ngIf="{
      screenSize: screenSize$ | async,
      plateaux: plateaux$ | async,
      ghostElements: ghostElements$ | async,
      user: user$ | async,
      categories: categories$ | async,
      competitions: competitions$ | async,
      divisions: divisions$ | async,
      groups: groups$ | async,
      days: days$ | async,
      weeks: weeks$ | async } as vm">

  <h1>
    {{ 'plateau.list.seo.title' | translate }}
  </h1>

  <p>
    {{ 'plateau.list.seo.description' | translate }}
  </p>

  <section>
    <mat-expansion-panel>
      <mat-expansion-panel-header>
        {{ 'plateau.list.filter.title' | translate }}
      </mat-expansion-panel-header>

      <form [formGroup]="formGroup">
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.category' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().category"
                                 (resetClick)="categoryChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.category"
                            [control]="formGroup.controls.category">
            <mat-select formControlName="category" (selectionChange)="categoryChange($event.value)">
              <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                          [value]="category.slug">
                {{ category.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.competition' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().competition"
                                 (resetClick)="competitionChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.competition"
                            [control]="formGroup.controls.competition">
            <mat-select formControlName="competition" (selectionChange)="competitionChange($event.value)">
              <mat-option *ngFor="let competition of vm.competitions?.items; trackBy: trackBySlug"
                          [value]="competition.slug">
                {{ competition.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.division' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().division"
                                 (resetClick)="divisionChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.division"
                            [control]="formGroup.controls.division">
            <mat-select formControlName="division" (selectionChange)="divisionChange($event.value)">
              <mat-option *ngFor="let division of vm.divisions?.items; trackBy: trackBySlug"
                          [value]="division.slug">
                {{ division.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.group' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().group"
                                 (resetClick)="groupChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.group"
                            [control]="formGroup.controls.group">
            <mat-select formControlName="group" (selectionChange)="groupChange($event.value)">
              <mat-option *ngFor="let group of vm.groups?.items; trackBy: trackBySlug"
                          [value]="group.slug">
                {{ group.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.day' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().day"
                                 (resetClick)="dayChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.day"
                            [control]="formGroup.controls.day">
            <mat-select formControlName="day" (selectionChange)="dayChange($event.value)">
              <mat-option *ngFor="let day of vm.days?.items; trackBy: trackBySlug"
                          [value]="day.slug">
                {{ day.index }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <span class="spacer" *ngIf="vm.screenSize === SCREEN_SIZES['md']"></span>
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.period.week.label' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().week"
                                 (resetClick)="weekChange(undefined)">
          </app-reset-button-icon>
          <app-async-select [loading]="loading.week"
                            [control]="formGroup.controls.week">
            <mat-select formControlName="week" (selectionChange)="weekChange($event.value)"
                        [compareWith]="compareByWeek">
              <mat-option *ngFor="let week of vm.weeks; trackBy: trackBySlug"
                          [value]="week">
                {{ 'plateau.list.filter.period.week.value' | translate:{ week: week.week, start: week.start.format('DD/MM/YYYY'), end: week.end.format('DD/MM/YYYY') } }}
              </mat-option>
            </mat-select>
          </app-async-select>
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.period.start' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().startDate"
                                 (resetClick)="formGroup.controls.startDate.patchValue(undefined)">
          </app-reset-button-icon>
          <mat-datepicker-toggle [for]="startDatePicker" matSuffix></mat-datepicker-toggle>
          <mat-datepicker #startDatePicker [startAt]="formGroup.value.startDate || formGroup.value.endDate"></mat-datepicker>
          <input matInput formControlName="startDate"
                 [matDatepicker]="startDatePicker" autocomplete="false">
        </mat-form-field>
        <mat-form-field>
          <mat-label>
            {{ 'plateau.list.filter.period.end' | translate }}
          </mat-label>
          <app-reset-button-icon matPrefix
                                 [display]="!!formGroup.getRawValue().endDate"
                                 (resetClick)="formGroup.controls.endDate.patchValue(undefined)">
          </app-reset-button-icon>
          <mat-datepicker-toggle [for]="endDatePicker" matSuffix></mat-datepicker-toggle>
          <mat-datepicker #endDatePicker [startAt]="formGroup.value.endDate || formGroup.value.startDate"></mat-datepicker>
          <input matInput formControlName="endDate"
                 [matDatepicker]="endDatePicker" autocomplete="false">
        </mat-form-field>
      </form>

    </mat-expansion-panel>
  </section>

  <section class="items">
    <ng-template #items>
      <app-plateau-list-item *ngFor="let plateau of vm.plateaux?.items; trackBy: trackBySlug"
                             [plateau]="plateau" [user]="vm.user"></app-plateau-list-item>
    </ng-template>
    <ng-container *ngIf="loading.list; else items">
      <app-plateau-list-item-ghost *ngFor="let plateau of vm.ghostElements"></app-plateau-list-item-ghost>
    </ng-container>
  </section>

</ng-container>
